<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;
use App\Http\Models\ItempindahsubinvModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
class ItempindahsubinvService extends BaseService
{
    /**
     ItempindahsubinvService constructor.
    */
    public function __construct()
    {
        parent::__construct();
        $this->model= new ItempindahsubinvModel();
    }

	/**
	*  index function that get all data from database by default
	*  @return array|static[]
	*/
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	*  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	*  @param array $input
	*  @return array
	*/
	public function paging($input)
	{
		$this->model->joinRelationItemId()->joinRelationMoNumber()->getQuery()->select(["itempindahsubinv.id as id",
			"itemId.id as itemId",
			"moNumber.moNumber as moNumber",
			"itempindahsubinv.needBy as needBy",
			"itempindahsubinv.quantity as quantity",
			"itempindahsubinv.satuan as satuan"]);
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	*  get one raw row data from table by id
	*  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	*  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	*  and you want to take value like this $model->fieldname
	*  @param $id
	*  @return ItempindahsubinvModel
	*/
	public function show($id)
	{
		$model=$this->model->getQuery()->where("itempindahsubinv.id","=",$id)->first();
		return $model;
	}


	/**
	*  this is a base function for storing data you with transaction by default
	*  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	*  @param array $input
	*  @return ItempindahsubinvModel
	*  @throws \Exception
	*/
	public function store($input)
	{
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			$newInput = $this->getPrepare($input);
			if(! empty($newInput)) {
				/* if(! $this->model->insert($newInput)) {
					throw new \Exception();
				} */
				foreach($newInput as $row) {
					$itemBrg = new ItempindahsubinvModel();
					$itemBrg->fill($row);
					if(! $itemBrg->save()) {
						throw new \Exception();
					}
				}
				return $this->model;
			}
		}
	}

	private function getPrepare($input) {
		$data = [];
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $stokID => $itemID) {
				$data[] = [	"moNumber" 	=> $input["moNumber"],
							"itemId" 	=> $itemID,
							"lotNumber" => $input["lotNumber"][$stokID],
							"quantity" 	=> $input["quantity"][$stokID],
							"stokId" 	=> $input["stokID"][$stokID]
				];
			}
		}
		return $data;
	}


	/**
	* this function will delete much data, in one action
	* the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	* you can remove this main alogorithm with your business requirement like soft delete or anything you want
	*  @param $ids
	*/
	public function delete($ids){
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	*  this is a base function for update and delete data by default.
	*  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	*  you can add multiple relation proses after update in this function 
	*  @param $id
	*  @param array $input 
	*  @return ItempindahsubinvModel
	*  @throws \Exception
	*/
	public function update($id,$input)
	{
		$itempindahsubinv = ItempindahsubinvModel::find($id);
		$itempindahsubinv->fill($input);
		if(!$itempindahsubinv->update()){
			throw new \Exception();
		}
		return $itempindahsubinv;
	}


	/**
	*  this function will be confirting paging property into file excel
	*  the main library is base on excel spreadsheet library
	*  @param array $input
	*   @return array|static[]
	*/
	public function exportToExcel($input =array())
	{
		return $this->model->getQuery()->get();
	}

	public function showBasedOnPindahSubinv($request, $headerTransaction) {
		$auth = json_decode($request->session()->get('auth'));

		$model = $this->model->joinRelationItemId()->joinRelationStokId()->getQuery()
		->where("itempindahsubinv.moNumber", "=", $headerTransaction->moNumber)
		->where("itemId.kapalId", "=", $headerTransaction->kapalId)
		->whereIn("itemId.type_id", $auth->arrCategory)
		->select([	"itempindahsubinv.id as id",
					"itempindahsubinv.moNumber as moNumber",
					"itempindahsubinv.lotNumber as lotNumber",
					"itempindahsubinv.stokId as stokId",
					"itempindahsubinv.quantity as quantity",
					"itemId.namaItem as namaItem",
					"itemId.part_number as part_number",
					"itemId.deskripsi as deskripsi",
					"itemId.category as category",
					"itemId.id as itemId",
					"itemId.item_price as harga_satuan",
					"itemId.UOM as UOM",					
					"stokId.jumlah as qtyStock"])->get();
		return $model;
	}
}